use v6.e.PREVIEW;

use HTML::Functional;
use DB::BlogMeta;

unit class Config;

# TODO: Support GFM admonitions
method generate-post(Str:D $title, Str:D $content, BlogMeta:D $meta) {
    my $head = head [
        meta :charset<utf-8>;
        meta :name<viewport>, :content<width=device-width, initial-scale=1>;
        title "{$meta.title} — $title";
        # TODO: Add style sheets
        # Use Iosevka Alie as the monospace font
        link :rel<stylesheet>,
            :href<https://static.stranger.systems/fonts/IosevkaAlie/IosevkaAile.css>;
        # Use open sans as the content font
        link :rel<preconnect> :href<https://fonts.googleapis.com>;
        link :rel<preconnect> :href<https://fonts.gstatic.com> :crossorigin;
        link :rel<stylesheet>,
            :href<https://fonts.googleapis.com/css2?family=Open+Sans:ital,wght@0,300..800;1,300..800&display=swap>;
        style %?RESOURCES<main.css>.slurp;
        style %?RESOURCES<code.css>.slurp;
        # TODO: Add description
        # TODO: Add header links
    ];
    my $body =
    body [
       div :class<post-body>, [
          $content
       ]
    ];
    # TODO: Setup footer
    # my $footer;

   my $html = html :lang<en>, [
       $head,
       $body
   ];

   "<!doctype html>$html"
}
